<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';

interface HeroImage {
  src: string;
  alt?: string;
}

interface HeroButton {
  text: string;
  externalUrl: string;
  variation?: string;
  iconName: string;
  iconVariant: string;
  size?: string;
}

export default Vue.extend({
  props: {
    header: {
      type: String,
      required: true,
    },
    subtitle: {
      type: String,
      required: false,
      default: '',
    },
    image: {
      type: Object as PropType<HeroImage>,
      required: true,
    },
    button: {
      type: Object as PropType<HeroButton>,
      required: false,
      default: null,
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <SlpContainer>
      <div class="hero-wrapper">
        <div class="hero-text">
          <img
            src="https://images.ctfassets.net/xz1dnu24egyd/1tHsfp1UKNZPdULa6HZgFH/9942d52a305a25f743207a26aed091e0/gitlablogo.svg"
            alt="GitLab Logo"
          />
          <SlpTypography variant="heading1-bold" tag="h1" class="slp-mb-24">{{
            header
          }}</SlpTypography>
          <SlpTypography variant="body2" tag="h2" class="slp-mb-24">{{
            subtitle
          }}</SlpTypography>
          <SlpButton :href="button.externalUrl" :variant="button.variation"
            >{{ button.text }}
            <SlpIcon
              v-if="button.iconName"
              :name="button.iconName"
              :variant="button.iconVariant"
              class="slp-ml-8"
          /></SlpButton>
        </div>
        <div v-if="image?.src" class="hero-image">
          <img :src="image.src" :alt="image.alt" />
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  background-color: #2f2a6b;
  margin-bottom: 96px;
  position: relative;
  &:before {
    display: none;
    content: '';
    position: absolute;
    height: 100%;
    width: 100%;
    left: 0;
    top: 0;
    background: url('/nuxt-images/events/world-tour/hero-graphics.png');
    background-repeat: no-repeat;

    background-size: auto 400px;
    background-position: center center;
    @media (min-width: $breakpoint-md) {
      display: block;
      width: 50%;
    }
    @media (min-width: $breakpoint-lg) {
      background-size: 620px;
      background-position: center left;
    }
    @media (min-width: 1600px) {
      background-size: 100%;
      background-position: top left;
      width: 40%;
    }
  }
  &:after {
    display: none;
    content: '';
    position: absolute;
    height: 100%;
    width: 100%;
    right: 0;
    top: 0;
    background: url('/nuxt-images/events/world-tour/hero-graphics.svg');
    background-repeat: no-repeat;
    background-size: 100%;
    background-position: 100% 79%;
    @media (min-width: $breakpoint-md) {
      display: block;
      width: 23%;
    }
    @media (min-width: $breakpoint-lg) {
      background-size: 240px;
      background-position: 100% 79%;
    }
  }
}
.hero-wrapper {
  display: flex;
  flex-direction: column-reverse;
  align-items: center;
  gap: 32px;
  position: relative;
  z-index: 1;
  // margin-top: $spacing-32;
  padding: 70px 0;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    justify-content: space-around;
    align-items: center;
  }
  @media (min-width: $breakpoint-lg) {
    // gap: 132px;
    justify-content: space-between;
  }

  .hero-text {
    min-width: 30%;
    color: #fff;
    @media (min-width: $breakpoint-md) {
      padding: 60px 0;
    }
    @media (min-width: $breakpoint-lg) {
      padding: 60px 0 90px 0;
    }
    &--expand {
      min-width: 45%;
    }
    .cta {
      white-space: nowrap;
    }
    .breadcrumbs {
      :deep {
        a[href] {
          span {
            color: white;
          }
        }
        span {
          color: #a2a1a6;
        }
      }
      //   :deep(span) {
      //   color: white;
      //   white-space: nowrap;

      // }
    }
    .location {
      display: flex;
      flex-direction: row;
      gap: 8px;
      @media (min-width: $breakpoint-lg) {
        white-space: nowrap;
      }

      .address:deep(p) {
        font-weight: 400;
        font-size: 20px;
        line-height: 24px;
      }
    }
    @media (min-width: $breakpoint-md) {
      flex: 1 0 33%;
    }
  }
  .hero-image {
    max-width: 100%;
    text-align: center;
    width: 100%;
    @media (min-width: $breakpoint-md) {
      max-width: 65%;
      // align-self: flex-end;
      flex: 0 0 58%;
    }
    img {
      margin-bottom: -7px;
      width: 100%;
      @media (min-width: $breakpoint-lg) {
        max-width: unset;
        width: 100%;
      }
    }
    @media (min-width: $breakpoint-md) {
      margin: 0;
    }
  }
}
</style>
